//Lua for Dan!

//hooray!

//sees if we press Spin
addHook("PlayerThink", function(player)
	if player.mo.skin == "dannygreg" then
		if not (player.cmd.buttons & BT_SPIN) then
			player.Spintapready = true
			player.Spintapping = false
		elseif player.Spintapready then
			player.Spintapping = true
			player.Spintapready = false
		else
			player.Spintapping = false
		end
	end
end)

//sees if we press jump
addHook("PlayerThink", function(player)
	if player.mo.skin == "dannygreg" then
		if not (player.cmd.buttons & BT_JUMP) then
			player.jumptapready = true
			player.jumptapping = false
		elseif player.jumptapready then
			player.jumptapping = true
			player.jumptapready = false
		else
			player.jumptapping = false
		end
	end
end)

//sweep kick and slide attack
//initiation
addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "dannygreg")
		if player.speed <= 30*FRACUNIT and player.speed >= 0 - 10*FRACUNIT
		and player.Spintapping and not player.danskick 
		and P_IsObjectOnGround(player.mo) then
			player.danskick = true
			player.dankinitang = player.drawangle
		elseif player.speed > 30*FRACUNIT and player.speed >= 0 - 10*FRACUNIT
		and player.Spintapping and not player.danskick 
		and P_IsObjectOnGround(player.mo) then
			player.mo.state = S_PLAY_SLIDE
			player.pflags = $ |PF_SPINNING
		elseif player.Spintapping and not P_IsObjectOnGround(player.mo)
		and player.danbcount < 3 then
			player.danbounc = 1
			player.danbcount = $ + 1
			P_SetObjectMomZ(player.mo, 0-35*FRACUNIT, false)
			player.mo.state = S_PLAY_ROLL
			player.pflags = $ |PF_SPINNING
		end
	end
end)

local DanIsKick = false
//the actual thing
addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "dannygreg")
		if player.danskick then
			DanIsKick = true
			player.pflags = $ |PF_FULLSTASIS
			player.danskang = $ or 0
			player.danskang = $ + 30*ANG1
			player.mo.state = S_PLAY_SLIDE
			player.drawangle = player.danskang
			player.dansktime = $ or 0
			player.dansktime = $ + 1
			if player.dansktime >= 15 then
				player.danskang = ANG1
				player.drawangle = player.dankinitang
				player.dansktime = 0
				player.danskick = false
				player.mo.state = S_PLAY_WALK
				DanIsKick = false
			end
		end
	end
end)


//makes the sweep kick attack
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "dannygreg"
	and player.danskick
	return true end
end)

addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "dannygreg"
	and player.mo.state == S_PLAY_ROLL
	return true end
end)

//bouncing
addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "dannygreg")
		player.danbcount = $ or 0
		if player.danbounc == 1 and P_IsObjectOnGround(player.mo) then
			P_SpawnSpinMobj(player, MT_JIMDUST)
			if player.danbcount == 1 then
				P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
				S_StartSound(player.mo, sfx_s3k7b)
			elseif player.danbcount == 2 then
				P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
				S_StartSound(player.mo, sfx_s3k44)
			elseif player.danbcount == 3 then
				P_SetObjectMomZ(player.mo, 20*FRACUNIT, false)
				S_StartSound(player.mo, sfx_s3k44)
			end
			player.mo.state = S_PLAY_ROLL
			player.danbounc = 2
		elseif player.danbounc == 2 and P_IsObjectOnGround(player.mo) then
			player.danbounc = 0
			player.danbcount = 0
		end
	end
end)

--[[addHook("MobjThinker", function(mo)
	if mo and mo.valid and DanIsKick then
		P_SetObjectMomZ(mo, 1*FRACUNIT, true)
	end
end)]]

--[[searchBlockmap("objects", function(p, m)
    if p.player and p.valid and m and m.valid and DanIsKick then
        P_SetObjectMomZ(m, 1*FRACUNIT, true)
    end
end,p, p.x-64*FRACUNIT, p.y-64*FRACUNIT, p.x+64*FRACUNIT, p.y+64*FRACUNIT)]]


-- Smooth Trail script by ffoxD.
-- i crediting them because they are way past cool!
local function SmoothTrail(mo, trailmo, freq)
    -- Real Z momentum thingy plus leveltime checks.
    -- You can replace all this with mo.momz+mo.pmomz but that stays at 0 when on slopes and on ground.
    if not mo.prevz or not mo.prevleveltime or (mo.prevleveltime ~= leveltime - 1) then
       mo.prevz = mo.z
    end
    local rmomz = mo.z - mo.prevz
    mo.prevz = mo.z
    mo.prevleveltime = leveltime
    -- Handy local variables.
    local mospeed = R_PointToDist2(0, 0, R_PointToDist2(0, 0, mo.momx, mo.momy), rmomz)
    local dist = (mospeed/freq)
    -- The loop, repeats until it spawns all the thok objects.
    for i = dist, 1, -1 do
        local spawnedmo = P_SpawnMobjFromMobj(mo, (mo.momx/dist)*i, (mo.momy/dist)*i, (rmomz/dist)*i, trailmo)
        spawnedmo.color = mo.color
        spawnedmo.blendmode = AST_ADD -- blend
    end
end

addHook("PlayerThink", function(player)
	if (player.mo.valid) and (player.mo.skin == "dannygreg")
		if (player.pflags & PF_THOKKED) and not P_IsObjectOnGround(player.mo) 
		and not player.dandused
		or player.dantimeruse != 0 and not P_IsObjectOnGround(player.mo) then
			player.dantimeruse = $ or 0
			player.dantimeruse = $ + 1
			player.dandused = true
			if player.dantimeruse <= 15 then
				P_InstaThrust(player.mo, player.drawangle, 30*FRACUNIT)
				P_SetObjectMomZ(player.mo, 0, false)
				SmoothTrail(player.mo, MT_JIMBALL, 4*FRACUNIT)
			elseif player.dantimeruse > 15 then
				player.dantimeruse = 0
			end
		elseif P_IsObjectOnGround(player.mo) then
			player.dandused = false
		end
	end
end)


