//freeslotting
freeslot("S_PLAY_NRSTRSONT", "SPR2_PSON", "SPR_PLAY")

states[S_PLAY_NRSTRSONT] = {
        sprite = SPR_PLAY,
		default = SPR2_EDGE,
        frame = SPR2_PSON|FF_ANIMATE,
        tics = 20,
		var1 = 4,
		var2 = 5,
        nextstate = S_PLAY_NRSTRSONT,
}

//stat reset
addHook("PlayerSpawn", function(player)
	player.nbobsped = 0
	player.nbobdrif = 0
	player.nbobDrec = 0
end)

//sees if we press Spin
addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" then
		if not (player.cmd.buttons & BT_SPIN) then
			player.Spintapready = true
			player.Spintapping = false
		elseif player.Spintapready then
			player.Spintapping = true
			player.Spintapready = false
		else
			player.Spintapping = false
		end
	end
end)



//acceleration
addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" then
		player.nbobsped = $ or 0
		if (player.cmd.buttons & BT_CUSTOM1) and player.nbobsped <= 38 then
			player.nbobsped = $ + 1
		elseif player.nbobsped >= 39 then
			player.nbobsped = 37
		elseif (player.cmd.buttons & BT_SPIN) and player.nbobsped >= 0 - 38 then
			player.nbobsped = $ - 1
		elseif player.nbobsped <= 0 - 39
			player.nbobsped = 0 - 37
		elseif player.speed <= 0
			player.nbobsped = 0
		elseif player.nbobsped <= 0 - 1
			player.nbobsped = $ + 1
		else
			player.nbobsped = $ - 1
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" and player.powers[pw_carry] == CA_NONE then
		P_InstaThrust(player.mo ,player.mo.angle,player.nbobsped*FRACUNIT + player.nbobdrif)
		player.mo.angle = player.mo.angle
	end
end)

//steering
addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" and player.mo.momx != 0 and player.mo.momy != 0
	and player.nbobDrec == 0 then
	//right (weak to strong)
		if (player.cmd.sidemove >= 1 and player.cmd.sidemove <= 10)
			player.mo.angle = player.mo.angle - 1*ANG1
			player.drawangle = player.mo.angle
		elseif (player.cmd.sidemove >= 11 and player.cmd.sidemove <= 20)
			player.mo.angle = player.mo.angle - 2*ANG1
			player.drawangle = player.mo.angle - 11*ANG1
		elseif (player.cmd.sidemove >= 21 and player.cmd.sidemove <= 30)
			player.mo.angle = player.mo.angle - 3*ANG1
			player.drawangle = player.mo.angle - 22*ANG1
		elseif (player.cmd.sidemove >= 31 and player.cmd.sidemove <= 40)
			player.mo.angle = player.mo.angle - 4*ANG1
			player.drawangle = player.mo.angle - 33*ANG1
		elseif (player.cmd.sidemove >= 41 and player.cmd.sidemove <= 50)
			player.mo.angle = player.mo.angle - 5*ANG1
			player.drawangle = player.mo.angle - 44*ANG1
			//left (weak to strong)
		elseif (player.cmd.sidemove >= 0 - 10 and player.cmd.sidemove <= 0 - 1)
			player.mo.angle = player.mo.angle + 1*ANG1
			player.drawangle = player.mo.angle
		elseif (player.cmd.sidemove >= 0 - 20 and player.cmd.sidemove <= 0 - 11)
			player.mo.angle = player.mo.angle + 2*ANG1
			player.drawangle = player.mo.angle + 11*ANG1
		elseif (player.cmd.sidemove >= 0 - 30 and player.cmd.sidemove <= 0 - 21)
			player.mo.angle = player.mo.angle + 3*ANG1
			player.drawangle = player.mo.angle + 22*ANG1
		elseif (player.cmd.sidemove >= 0 - 40 and player.cmd.sidemove <= 0 - 31)
			player.mo.angle = player.mo.angle + 4*ANG1
			player.drawangle = player.mo.angle + 33*ANG1
		elseif (player.cmd.sidemove >= 0 - 50 and player.cmd.sidemove <= 0 - 41)
			player.mo.angle = player.mo.angle + 5*ANG1
			player.drawangle = player.mo.angle + 44*ANG1
		end
	end
end)

//brakes or spin
addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" then
		if player.Spintapping then
			player.mo.state = S_PLAY_TWINSPIN
		elseif (player.cmd.buttons & BT_SPIN)
			player.nbobsped = $ - 1
		elseif player.mo.state == S_PLAY_TWINSPIN then
			player.nbspin = true
		elseif (player.cmd.buttons & BT_SPIN) 
		and player.mo.state != S_PLAY_TWINSPIN then
			player.mo.state = S_PLAY_SKID
			P_SpawnSpinMobj(player, MT_SMOKE)
		else
			player.nbspin = false
		end
	end
end)

//makes the spin attack
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.valid and player.mo.skin == "nbob"
	and player.nbspin
	return true end
end)

//emote
addHook("PlayerThink", function(player)
	if player.mo.skin == "nbob" then
		if not (player.cmd.buttons & BT_CUSTOM2) then
			player.emotapready = true
			player.emotapping = false
		elseif player.emotapready then
			player.emotapping = true
			player.emotapready = false
		else
			player.emotapping = false
		end

		if player.powers[pw_carry] == CA_NONE and player.mo.skin == "nbob" 
		and player.emotapping 
		and not player.dothing 
		and not player.exiting then
			player.dothing = true
		elseif player.mo.skin == "nbob" 
		and player.emotapping 
		and player.dothing 
		and not player.exiting then
			P_RestoreMusic(player)
			player.dothing = false
			player.mo.state = S_PLAY_STND
		elseif player.dothing then
			player.pflags = $ |PF_FULLSTASIS
			if player.mo.state != S_PLAY_RSTRSONT then
				player.mo.state = S_PLAY_RSTRSONT
			end
		end
	end
end)

addHook("BotTiccmd", function(bot)
	local player = players[0]
	local mo = players[0].mo
	if player.exiting then 
		return
	end
	if bot.mo and player.mo.skin == "nbob" and player and mo
		if player.dothing then
			if bot.mo.state != S_PLAY_RSTRSONT then
				bot.mo.state = S_PLAY_RSTRSONT
			elseif bot.mo.state == S_PLAY_RSTRSONT then
				bot.pflags = $ |PF_FULLSTASIS
			end
		elseif bot.mo.state == S_PLAY_RSTRSONT then
			bot.mo.state = S_PLAY_WALK
		end
	end
end)

//wall stop
addHook("MobjMoveBlocked", function(mo)
    if not mo.player then return end
	local player = players[0]
	local mo = players[0].mo
	if player.mo.skin == "nbob" and player.nbobsped >= 1 then
		player.nbobsped = $ - 10
	end
end)

//climbing
addHook("MobjMoveBlocked", function(mo)
    if not mo.player then return end
	if mo.skin == "nbob" then
		mo.jimwallrun = $ or 0
		if mo.jimwallrun <= 3*TICRATE then
			P_InstaThrust(mo ,mo.angle, (10*FRACUNIT))
			if P_GetPlayerControlDirection(mo.player) == 0 then
				mo.momz = 0
				if mo.state != S_PLAY_RIDE then
					mo.state = S_PLAY_RIDE
				end
			elseif P_GetPlayerControlDirection(mo.player) == 1 then
				P_SetObjectMomZ(mo, 7*FRACUNIT, false)
				P_SpawnGhostMobj(mo)
				mo.jimwallrun = $ + 1
				if mo.state != S_PLAY_ROLL then
					mo.state = S_PLAY_ROLL
				end
			elseif P_GetPlayerControlDirection(mo.player) == 2 then
				P_SetObjectMomZ(mo,(0 - 14*FRACUNIT), false)
				P_SpawnGhostMobj(mo)
				mo.jimwallrun = $ + 1
				if mo.state != S_PLAY_FALL then
					mo.state = S_PLAY_FALL
				end
			end
		end
	end
end)

addHook("MobjThinker", function(mo)
	local player = players[0]
	if not mo.player then return end
	if mo.skin == "nbb" then
		mo.jimwallrun = $ or 0
		if P_IsObjectOnGround(mo) 
		and player.speed == 0
		and mo.jimwallrun >= 1 then
			mo.jimwallrun = $ - 1
		elseif (mo.player.cmd.buttons & BT_CUSTOM1) 
		and mo.jimwallrun <= 3*TICRATE 
		and mo.jimwallrun >= 1 then
			P_InstaThrust(mo ,mo.angle, (10*FRACUNIT))
		end
	end
end)