if not (symbolArts)
    local symbolart_sounds = {
        "SA_NORMAL",
        "SA_JOY",
        "SA_ANGER",
        "SA_SORROW",
        "SA_UNEASE",
        "SA_SURPRISED",
        "SA_DOUBT",    // SA_QUESTION
        "SA_HELP",
        "SA_WHISTLE",
        "SA_EMBARRASSMENT",    // SA_SHYNESS
        "SA_NAILEDIT",    // SA_DECISIVE
    }
    for k, v in ipairs(symbolart_sounds)
        local index = k
        if (k > 9) then index = (k == 10) and "A" or "B" end
        
        freeslot("sfx_sasfx"..index)
        rawset(_G, v, sfx_sasfx1 + (k-1))
    end
    
    rawset(_G, "symbolArts", {})
end